package jrummikub.ai.fdsolver;

import static org.junit.Assert.assertEquals;
import jrummikub.ai.fdsolver.constraint.LessThan;
import jrummikub.ai.fdsolver.constraint.LessThanConst;

import org.junit.Test;

public class SolverTest {
	@Test
	public void test() {
		Solver solver = new Solver();

		Var<Integer> x = solver.makeVar(1, 2, 3);
		Var<Integer> y = solver.makeRangeVar(1, 13);
		
		solver.addConstraint(new LessThan<Integer>(false, y, x));
		
		int lastx = 0, lasty = 0;
		while (solver.solve()) {
			lastx = x.getValue();
			lasty = y.getValue();
			solver.addConstraint(new LessThanConst<Integer>(false, x, x.getValue()));
		}

		assertEquals(2, lastx);
		assertEquals(1, lasty);
	}
}
